var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import A from '../a/index';
import cn from 'classnames';
import IconCheck from '../icon/check';
import './style.scss';
var Radio = function (props) {
    var checked = props.checked, disabled = props.disabled, className = props.className, text = props.text, onChange = props.onChange, otherProps = __rest(props, ["checked", "disabled", "className", "text", "onChange"]);
    var composeClassName = cn('x-radio', {
        'x-radio__checked': checked,
        'x-radio__disabled': disabled,
    }, className);
    var onClick = function () {
        if (disabled) {
            return;
        }
        onChange(!checked);
    };
    return (<A {...otherProps} className={composeClassName} onClick={onClick}>
      <i className="x-radio__icon">
        <IconCheck />
      </i>
      {!!text && <span className="x-radio__text">{text}</span>}
    </A>);
};
export default Radio;
