var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import A from '../a/index';
import cn from 'classnames';
import IconCheck from '../icon/check';
import IconClose from '../icon/close';
import './style.scss';
var Switch = function (props) {
    var i = props.i, o = props.o, active = props.active, icon = props.icon, disabled = props.disabled, className = props.className, onChange = props.onChange, otherProps = __rest(props, ["i", "o", "active", "icon", "disabled", "className", "onChange"]);
    var composeClassName = cn('x-switch', {
        'x-switch--active': active,
        'x-switch--io': i && o,
        'x-switch--disabled': disabled,
    }, className);
    var hasIO = !!i && !!o;
    var onClick = function () {
        if (disabled) {
            return;
        }
        onChange(!active);
    };
    return (<A {...otherProps} className={composeClassName} onClick={onClick}>
      {hasIO && <sub>{props.i}</sub>}
      {hasIO && <sup>{props.o}</sup>}
      <em>
        {icon && !active && <IconClose />}
        {icon && active && <IconCheck />}
      </em>
    </A>);
};
export default Switch;
