var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from 'react';
import A from '../a/index';
import cn from 'classnames';
import './style.scss';
var TabsItem = function (props) {
    var active = props.active, value = props.value, className = props.className, onClick = props.onClick, children = props.children, otherProps = __rest(props, ["active", "value", "className", "onClick", "children"]);
    var composeClassName = cn('x-tabs__item', {
        'x-tabs--active': !!active,
    }, className);
    var onAClick = function () {
        onClick(value);
    };
    return (<A {...otherProps} className={composeClassName} onClick={onAClick}>
      {children}
    </A>);
};
var Tabs = function (props) {
    var className = props.className, children = props.children, active = props.active, onClick = props.onClick, otherProps = __rest(props, ["className", "children", "active", "onClick"]);
    var composeClassName = cn('x-tabs', className);
    var activeOffset = -2;
    var composeChildren = [];
    if (Array.isArray(children)) {
        composeChildren.push.apply(composeChildren, children);
    }
    else {
        composeChildren.push(children);
    }
    composeChildren = composeChildren.map(function (res, index) {
        var act = props.hasOwnProperty('active') && res.props.value === props.active;
        if (act) {
            activeOffset = index;
        }
        return React.cloneElement(res, {
            active: act,
            key: index,
            value: res.props.value,
            onClick: props.onClick,
            children: res.props.children,
        });
    });
    var len = composeChildren.length;
    return (<div {...otherProps} className={composeClassName}>
      <sub className="x-tabs__line" style={{
        width: 100 / len + "%",
        WebkitTransform: "translate(" + activeOffset * 100 + "%,0)",
    }}/>
      {composeChildren}
    </div>);
};
Tabs.Item = TabsItem;
export default Tabs;
